From 3829769f46fefa6e7c416cc1ee5e84d7d653f2f0 Mon Sep 17 00:00:00 2001
From: Alexander Polakov <plhk@sdf.org>
Date: Thu, 20 Dec 2012 16:23:27 +0400
Subject: [PATCH 02/11] Handle _NET_CLOSE_WINDOW ClientMessage

---
 calmwm.h  | 1 +
 xevents.c | 3 +++
 xutil.c   | 1 +
 3 files changed, 5 insertions(+)

diff --git a/calmwm.h b/calmwm.h
index 4a856fb..923bde9 100644
--- a/calmwm.h
+++ b/calmwm.h
@@ -554,6 +554,7 @@ enum {
 #define _NET_WM_STATES_NITEMS 	2
 	_NET_WM_STATE_MAXIMIZED_VERT,
 	_NET_WM_STATE_MAXIMIZED_HORZ,
+	_NET_CLOSE_WINDOW,
 	EWMH_NITEMS
 };
 struct atom_ctx {
diff --git a/xevents.c b/xevents.c
index a157143..3d5a757 100644
--- a/xevents.c
+++ b/xevents.c
@@ -353,6 +353,9 @@ xev_handle_clientmessage(XEvent *ee)
 	if (e->message_type == xa_wm_change_state && e->format == 32 &&
 	    e->data.l[0] == IconicState)
 		client_hide(cc);
+
+	if (e->message_type == ewmh[_NET_CLOSE_WINDOW].atom && e->format == 32)
+		client_send_delete(cc);
 }
 
 static void
diff --git a/xutil.c b/xutil.c
index b422f58..49d8c36 100644
--- a/xutil.c
+++ b/xutil.c
@@ -257,6 +257,7 @@ struct atom_ctx ewmh[EWMH_NITEMS] = {
 	{"_NET_WM_STATE", 		None},
 	{"_NET_WM_STATE_MAXIMIZED_VERT",None},
 	{"_NET_WM_STATE_MAXIMIZED_HORZ",None},
+	{"_NET_CLOSE_WINDOW", 		None},
 };
 
 void
-- 
1.8.1.2

